/*
 * This source file is part of KEOS (Free 3D Engine)
 * For the latest info, see http://www.keosengine.org/
 * E-mails : thierry.vouriot@keosengine.org, yeri@keosengine.org
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA, or go to
 * http://www.gnu.org/copyleft/lesser.txt.
 *
 */

#include "KeosResourceManager.h"
#include "KeosLogger.h"
#include "KeosException.h"
#include "KeosResource.h"

namespace Keos
{
    //=======================================================================
    // CResourceManager implementation
    //=======================================================================

    //-----------------------------------------------------------------------
    CResourceManager::CResourceManager()
    {
        ILogger::Log("--> Create ResourceManager");
    }

    //-----------------------------------------------------------------------
    CResourceManager::~CResourceManager()
    {
        ILogger::Log("<-- Destroy ResourceManager");
        if (!m_Resources.empty())
        {
            ILogger::Log("WARNING - Some resources have not been released :");

            for (TResourcesMap::const_iterator i = m_Resources.begin(); i != m_Resources.end(); ++i)
            {
                ILogger::Log(" - %s",i->second->GetName().c_str());
            }
        }
    }

    //-----------------------------------------------------------------------
    void CResourceManager::Add(const String& strName, IResource* pResource)
    {
        Assert(pResource != NULL);

        if (m_Resources.find(strName) != m_Resources.end())
            ILogger::Log("WARNING - %s : resource already loaded !", strName.c_str());

        m_Resources[strName] = pResource;
        pResource->m_strName = strName;
    }

    //-----------------------------------------------------------------------
    void CResourceManager::Remove(const String& strName)
    {
        TResourcesMap::iterator It = m_Resources.find(strName);

        if (It == m_Resources.end())
            ILogger::Log("WARNING - %s : resource destroyed but not loaded !", strName.c_str());

        m_Resources.erase(It);
    }

} // namespace Keos
